#ifndef __AD9129_H_
#define __AD9129_H_

#include "devices.h"

const reg_with_name_t ad9129_init_regs[] =
{
	// start-up sequence after power up
	{ 0x00, 3, 0x00, 0x81, "MODE" },
	{ 0x30, 3, 0x5C, 0x00, "CLK_REG1" },
	{ 0x0C, 3, 0x64, 0x23, "DATA_CTRL_2" },
	{ 0x0B, 3, 0x39, 0x29, "DATA_CTRL_1" },
	{ 0x01, 3, 0x68, 0x48, "POWER_DOWN" },
	{ 0x34, 3, 0x6D, 0x55, "RETIMER_CTRL_1" },
	{ 0x01, 3, 0x48, 0x48, "POWER_DOWN" },
	{ 0x33, 3, 0x13, 0x30, "RETIMER_CTRL_0" },
	{ 0x33, 3, 0xF8, 0x30, "RETIMER_CTRL_0" },
	{ 0x33, 3, 0xF0, 0x30, "RETIMER_CTRL_0" },
	{ 0x0D, 3, 0x06, 0x04, "DATA_CTRL_3" },
	{ 0x0A, 3, 0xC0, 0x40, "DATA_CTRL_0" },
	{ 0x18, 3, 0x00, 0x00, "DATA_MODE_CTRL" },
	{ 0x20, 3, 0xC6, 0x00, "FSC_1" },
	{ 0x21, 3, 0x03, 0x02, "FSC_2" },
	{ 0x30, 3, 0x46, 0x00, "CLK_REG1" },
	{ 0x12, 3, 0x20, 0x04, "FIFO_OFFSET" },
	{ 0x11, 3, 0x81, 0x00, "FIFO_CTRL" },
	{ 0x11, 3, 0x01, 0x00, "FIFO_CTRL" },
	{ 0x7C, 3, 0x80, 0x00, "DRIVE_STRENGTH" },
	{ 0x01, 3, 0x08, 0x48, "POWER_DOWN" },
	{ 0, 0, 0, 0, NULL}
};	
	
const reg_with_name_t ad9129_regs[] =
{
	{ 0x00, 3, 0, 0x81, "MODE" },
	{ 0x01, 3, 0, 0x48, "POWER_DOWN" },
	{ 0x03, 3, 0, 0x00, "IRQ_EN0" },
	{ 0x04, 3, 0, 0x00, "IRQ_EN1" },
	{ 0x05, 3, 0, 0x00, "IRQ_REQ0" },
	{ 0x06, 3, 0, 0x00, "IRQ_REQ1" },
	{ 0x07, 3, 8, 0x00, "FRAME_PIN_USAGE" },
	{ 0x08, 3, 0, 0x58, "RSVED_0" },
	{ 0x0A, 3, 3, 0x40, "DATA_CTRL_0" },
	{ 0x0B, 3, 0, 0x29, "DATA_CTRL_1" },
	{ 0x0C, 3, 0, 0x23, "DATA_CTRL_2" },
	{ 0x0D, 3, 3, 0x04, "DATA_CTRL_3" },
	{ 0x0E, 1, 0, 0x00, "DATA_STATUS_0. DLL [7:0] lock,warn,start_w,end_w,correct_phase,DCI_on,lock_phase,running " },
	{ 0x11, 3, 0, 0x00, "FIFO_CTRL" },
	{ 0x12, 3, 3, 0x04, "FIFO_OFFSET" },
	{ 0x13, 1, 0, 0x00, "FIFO_PH0_THRM" },
	{ 0x14, 1, 0, 0x00, "FIFO_PH1_THRM" },
	{ 0x15, 1, 3, 0x00, "FIFO_PH2_THRM" },
	{ 0x16, 1, 0, 0x00, "FIFO_PH3_THRM" },
	{ 0x18, 3, 0, 0x00, "DATA_MODE_CTRL. [7]filter_en [6]binary_sel:0=2's comp. [5]filter_sel: 1=40db" },
	{ 0x19, 3, 3, 0x00, "DECODE_CTRL" },
	{ 0x1A, 3, 0, 0x00, "SYNC" },
	{ 0x20, 3, 0, 0x00, "FSC_1" },
	{ 0x21, 3, 3, 0x02, "FSC_2" },
	{ 0x22, 3, 0, 0x00, "ANA_CNT1" },
	{ 0x23, 3, 0, 0x0C, "ANA_CNT2" },
	{ 0x30, 3, 3, 0x00, "CLK_REG1" },
	{ 0x33, 3, 0, 0x30, "RETIMER_CTRL_0" },
	{ 0x34, 3, 0, 0x55, "RETIMER_CTRL_1" },
	{ 0x35, 1, 3, 0x00, "RETIMER_STAT_0" },
	{ 0x50, 3, 0, 0x00, "SED_CTRL" },
	{ 0x51, 3, 0, 0x00, "SED_PATT_ERR_R0L" },
	{ 0x52, 3, 3, 0x00, "SED_PATT_ERR_R0H" },
	{ 0x53, 3, 0, 0x00, "SED_PATT_ERR_R1L" },
	{ 0x54, 3, 0, 0x00, "SED_PATT_ERR_R1H" },
	{ 0x55, 3, 3, 0x00, "SED_PATT_ERR_F0L" },
	{ 0x56, 3, 0, 0x00, "SED_PATT_ERR_F0H" },
	{ 0x57, 3, 0, 0x00, "SED_PATT_ERR_F1L" },
	{ 0x58, 3, 3, 0x00, "SED_PATT_ERR_F1H" },
	{ 0x5C, 3, 0, 0x00, "PARITY_CTRL" },
	{ 0x5D, 1, 0, 0x00, "PARITY_ERR_RISING" },
	{ 0x5E, 1, 3, 0x00, "PARITY_ERR_FAILING" },
	{ 0x70, 3, 0, 0xFF, "DEALY_CTRL_0" },
	{ 0x71, 3, 0, 0x67, "DEALY_CTRL_1" },
	{ 0x7C, 3, 3, 0x7C, "DRIVE_STRENGTH" },
	{ 0x7F, 1, 3, 0x07, "PART_ID" },
	{ 0, 0, 0, 0, NULL}
};


#endif /* __AD9129_H_ */