#ifndef __AD9234_H_
#define __AD9234_H_

#include "devices.h"

const reg_with_name_t ad9234_regs[] =
{
	{ 0x0000, 3, 0x81, 0x00, "Cfg_A"},
	{ 0x0000, 0x80, 6000, 0x00, "Delay at least 5ms after soft reset"},
	{ 0x0001, 3, 0x00, 0x00, "Cfg_B [7] single instr. [1] datapath soft reset (self clearing)"},
	{ 0x0002, 3, 0x00, 0x00, "Device configuration [1:0] 0: noraml 1:standby 2:powerdown"},
	{ 0x0003, 1, 0x03, 0x03, "Chip type = 0x03"},
	{ 0x0004, 1, 0xCE, 0xCE, "Chip ID low byte = 0xCE"},
	{ 0x0005, 1, 0x00, 0x00, "Chip ID high byte = 0x00"},
	{ 0x0006, 1, 0xA0, 0xA0, "Chip grade [7:4] 0xA=1GSPS; 0x5=500MSPS"},
	{ 0x0008, 3, 0x03, 0x03, "Device Index [1] ch B [0] ch A"},
	{ 0x0002, 2, 0x00, 0x00, "Device configuration [1:0] 0: noraml 1:standby 2:powerdown"},	// Write again after choose both channel (0x008=3)
	{ 0x000A, 3, 0x00, 0x00, "Scratch pad"},
	{ 0x000B, 3, 0x01, 0x01, "SPI version"},
	{ 0x000C, 1, 0x56, 0x56, "Vender ID = 0x56"},
	{ 0x000D, 1, 0x04, 0x04, "Vender ID = 0x04"},
	                          
	{ 0x0015, 3, 0x00, 0x00, "Analog input [0] input disable"},
	{ 0x0016, 3, 0x23, 0x23, "Input term. [7:4] 0: 400ohm 1:200ohm 2:100ohm 6:50ohm [3:0] 3:1GSPS 1:500M"},
	{ 0x0018, 3, 0x40, 0x30, "Input buffer current ctrl [7:4] 0: 1x 1:1.5x 2:2x ... 15:8.5x"},
	                          
	{ 0x0024, 3, 0x00, 0x00, "V_1P0 control [0] 0:internal 1:external"},
	{ 0x0028, 3, 0x00, 0x00, "Temp. diode [0] 0:no diode selected 1:temp diode selected"},
	{ 0x003F, 3, 0x00, 0x00, "Power/STBY pin ctrl [7] 0:enabled 1: disabled"},
	{ 0x0040, 3, 0x3F, 0x3F, "[7:6] PDWN function [5:3] FD_B [2:0] FD_A 0:Fast detect 1:LMFC 2:SYNC~ 3:temp. diode 7:disabled"},
	{ 0x010B, 3, 0x00, 0x00, "[2:0] Clock divide 0:1 1:2 3:4 7:8"},
	{ 0x010C, 3, 0x00, 0x00, "[3:0] clock divider phase"},
	{ 0x010D, 3, 0x00, 0x00, "Clock divider phase [7] auto phase adjust [3:2] negative skew window [1:0] positive skew window"},
	{ 0x0117, 3, 0x00, 0x00, "[0] Clock fine delay adjust enable 0:disabled"},
	{ 0x0118, 3, 0x00, 0x00, "[7:0] Clock fine delay adjust [7:0]"},
	{ 0x011C, 1, 0x00, 0x00, "[0] 0:no input clock detected; 1:detected"},
	{ 0x0120, 3, 0x02, 0x00, "SYSREF+ 1 [6] flag reset 0:normal 1:held in reset [4] transit sel 0:low to high [3] 0: CLK+ rising edge [2:1] mode 0:disabled 1:conti 2:N shot "},
	{ 0x0121, 3, 0x00, 0x00, "SYSREF+ 2 [3:0] N-shot ignore counter sel 0:next SYSREF+ only 1:ignore 1st SYSREF+ ..."},
	{ 0x0123, 3, 0x00, 0x00, "[6:0] SYSREF+ timestamp delay 0:no delay ... 0x7f:127 clocks delay"},
	{ 0x0128, 1, 0x00, 0x00, "SYSREF+ status 1 [7:4] hold [3:0] setup"},
	{ 0x0129, 1, 0x00, 0x00, "[3:0] Clock divider phase when SYSREF+ was cpatured"},
	{ 0x012A, 1, 0x00, 0x00, "[7:0] SYSREF+ counter"},

	{ 0x01FF, 3, 0x00, 0x00, "[1:0] Synchronization mode 0:normal 1:timestamp"},
	{ 0x0200, 3, 0x00, 0x00, "[5] Chip Q ignore 0:normal 1:I-only [1:0] mode 0:full bw 1: DDC0 2:DDC0 and DDC1"},
	{ 0x0201, 3, 0x00, 0x00, "[2:0] Chip decimation ratio 0:1 1:2"},
	{ 0x0228, 3, 0x00, 0x00, "Customer offset (+127~-128 2's complement)"},
	{ 0x0245, 3, 0x00, 0x00, "FD ctrl [3] force [2] force value [0] enable"},
	{ 0x0247, 3, 0x00, 0x00, "Fast detect upper threshold [7:0]"},
	{ 0x0248, 3, 0x00, 0x00, "[4:0] Fast detect upper threshold [12:8]"},
	{ 0x0249, 3, 0x00, 0x00, "Fast detect lower threshold [7:0]"},
	{ 0x024A, 3, 0x00, 0x00, "[4:0] Fast detect lower threshold [12:8]"},
	{ 0x024B, 3, 0x00, 0x00, "Fast detect dwell time [7:0]"},
	{ 0x024C, 3, 0x00, 0x00, "Fast detect dwell time [15:8]"},

	{ 0x026F, 3, 0x00, 0x00, "[1:0] Synchronization mode 0: disabled 1:continuous 2:one shot"},
	{ 0x0270, 3, 0x00, 0x00, "[1] Peak detector 0:disabled 1:enabled"},
	{ 0x0271, 3, 0x00, 0x00, "Signal monitor period [7:0]"},
	{ 0x0272, 3, 0x00, 0x00, "Signal monitor period [15:8]"},
	{ 0x0273, 3, 0x00, 0x00, "Signal monitor period [23:16]"},
	{ 0x0274, 3, 0x00, 0x00, "Signal monitor result ctrl [4] update [0] result sel 0:reserved 1:peak detector "},
	{ 0x0275, 1, 0x00, 0x00, "Signal monitor result [7:0]"},
	{ 0x0276, 1, 0x00, 0x00, "Signal monitor result [15:8]"},
	{ 0x0277, 1, 0x00, 0x00, "[3:0] Signal monitor result [19:16]"},
	{ 0x0278, 1, 0x00, 0x00, "Signal monitor period counter result [7:0]"},
	{ 0x0279, 3, 0x00, 0x00, "Signal monitor SPORT over JESD204B [1:0] 0: reserved 3:enable"},
	{ 0x027A, 3, 0x00, 0x00, "SPORT over JESD204B input selection [1] 0: peak detector disabled; 1:enabled"},
	// DDC function registers
	{ 0x0300, 3, 0x00, 0x00, "DDC sync ctrl [4] 0: NCO soft reset [1:0] sync mode 0:dis 1:conti. 2:1-shot"},
	{ 0x0310, 3, 0x00, 0x00, "DDC 0 ctrl [7] 0: real mixer 1:complex [6] gain 0:0dB 1:6dB [5:4] IF mode [3] complex to real en [1:0] deci rate sel"},
	{ 0x0311, 3, 0x00, 0x00, "DDC 0 input sel [2] Q input 0: chA 1:chB [0] I input"},
	{ 0x0314, 3, 0x00, 0x00, "DDC 0 frequency LSB [7:0]"},
	{ 0x0315, 3, 0x00, 0x00, "[3:0] DDC 0 frequency MSB [11:8]"},
	{ 0x0320, 3, 0x00, 0x00, "DDC 0 phase LSB [7:0]"},
	{ 0x0321, 3, 0x00, 0x00, "[3:0] DDC 0 phase MSB [11:8]"},
	{ 0x0327, 3, 0x00, 0x00, "DDC0 output test mode sel [2] Q 0:dis 1:en from Ch B; [0] 0: dis; 1:en from Ch A"},
	{ 0x0330, 3, 0x00, 0x00, "DDC 1 ctrl [7] 0: real mixer 1:complex [6] gain 0:0dB 1:6dB [5:4] IF mode [3] complex to real en [1:0] deci rate sel"},
	{ 0x0331, 3, 0x00, 0x00, "DDC 1 input sel [2] Q input 0: chA 1:chB [0] I input"},
	{ 0x0334, 3, 0x00, 0x00, "DDC 1 frequency LSB [7:0]"},
	{ 0x0335, 3, 0x00, 0x00, "[3:0] DDC 1 frequency MSB [11:8]"},
	{ 0x0340, 3, 0x00, 0x00, "DDC 1 phase LSB [7:0]"},
	{ 0x0341, 3, 0x00, 0x00, "[3:0] DDC 1 phase MSB [11:8]"},
	{ 0x0347, 3, 0x00, 0x00, "DDC1 output test mode sel [2] Q 0:dis 1:en from Ch B; [0] 0: dis; 1:en from Ch A"},
	// Digital ouputs and test modes
	{ 0x0550, 3, 0x00, 0x00, "ADC test modes [7] user ptn 0: cont. 1: single [5] reset PN long gen [4] reset PN short gen [3:0] test mode sel"},
	{ 0x0551, 3, 0x00, 0x00, "User ptn 1 [7:0]"},
	{ 0x0552, 3, 0x00, 0x00, "User ptn 1 [15:8]"},
	{ 0x0553, 3, 0x00, 0x00, "User ptn 2 [7:0]"},
	{ 0x0554, 3, 0x00, 0x00, "User ptn 2 [15:8]"},
	{ 0x0555, 3, 0x00, 0x00, "User ptn 3 [7:0]"},
	{ 0x0556, 3, 0x00, 0x00, "User ptn 3 [15:8]"},
	{ 0x0557, 3, 0x00, 0x00, "User ptn 4 [7:0]"},
	{ 0x0558, 3, 0x00, 0x00, "User ptn 4 [15:8]"},
	{ 0x0559, 3, 0x00, 0x00, "Ouput mode ctrl 1 [6:4] converter ctrl bit 1 sel [2:0] converter ctrl bit 0 sel"},
	{ 0x055A, 3, 0x01, 0x01, "Ouput mode ctrl 2 [2:0] converter ctrl bit 2 sel"},
	{ 0x0561, 3, 0x01, 0x01, "Ouput mode [2] sample invert [1:0] date format sel 0: offset binary 1: 2's complement"},
	{ 0x0562, 3, 0x00, 0x00, "Ouput overrange clear"},
	{ 0x0563, 3, 0x00, 0x00, "Ouput overrange status"},
	{ 0x0564, 3, 0x00, 0x00, "[0] converter channel swap"},
	{ 0x056E, 3, 0x00, 0x00, "[4] serial lane rate 0:>6.25Gbps 1:<6.25Gbps"},
	{ 0x05B0, 0, 0xFF, 0xAA, "Lane power down"},
	{ 0x0570, 3, 0x88, 0x88, "JESD204B quick config"},
	{ 0x0571, 3, 0x54, 0x14, "JESD204B link mode ctrl 1 [7] stby mode [6] tail bit [5]long transport layer test [4] lane sycn [3:2] ILAS mode [1] FACI [0] Link ctrl"},
	{ 0x0572, 3, 0x00, 0x00, "JESD204B link mode ctrl 2 [7:6] SYNCINB ctrl [5] SYNC invert [4] SYNC pin type [2] 8B/10B bypass [1] 8B/10B invert"},
	{ 0x0573, 3, 0x00, 0x00, "JESD204B link mode ctrl 3 [7:6] CHKSUM mode [5:4] Test injection point [3:0] test mode pattern"},
	{ 0x0574, 3, 0x00, 0x00, "JESD204B link mode ctrl 4 [7:4] ILAS delay [2:0] link layer test mode"},
	{ 0x0578, 3, 0x00, 0x00, "[4:0] LMFC phase offset"},
	{ 0x0580, 3, 0x00, 0x00, "JESD204B Tx DID [7:0]"},
	{ 0x0581, 3, 0x00, 0x00, "[3:0] JESD204B Tx BID [3:0]"},
	{ 0x0583, 3, 0x00, 0x00, "[4:0] Lane 0 LID[4:0]"},
	{ 0x0584, 3, 0x01, 0x01, "[4:0] Lane 1 LID[4:0]"},
	{ 0x0585, 3, 0x02, 0x02, "[4:0] Lane 2 LID[4:0]"},
	{ 0x0586, 3, 0x03, 0x03, "[4:0] Lane 3 LID[4:0]"},
	{ 0x058B, 3, 0x80, 0x83, "[7] scrambing enable [1:0] lanes 3:4 lanes read only"},
	{ 0x058C, 1, 0x88, 0x88, "F"},
	{ 0x058D, 3, 0x1F, 0x1F, "[4:0] K"},
	{ 0x058E, 1, 0x00, 0x00, "M"},
	{ 0x058F, 3, 0x0B, 0x0F, "[7:6] CS [4:0] N B:12-bit"},
	{ 0x0590, 3, 0x2F, 0x2F, "[7:5] Subclass [4:0] N'"},
	{ 0x0591, 1, 0x00, 0x00, "[5] = 1 [4:0] S"},
	{ 0x0592, 1, 0x80, 0x80, "[7] HD value [4:0] CF"},
	{ 0x05A0, 1, 0x81, 0x81, "CHKSUM for SERDOUT0"},
	{ 0x05A1, 1, 0x81, 0x82, "CHKSUM for SERDOUT1"},
	{ 0x05A2, 1, 0x81, 0x83, "CHKSUM for SERDOUT2"},
	{ 0x05A3, 1, 0x81, 0x84, "CHKSUM for SERDOUT3"},
	{ 0x05B0, 3, 0xAA, 0xAA, "Lane power down"},
	{ 0x05B2, 3, 0x00, 0x00, "SERDOUT0 lane assignment"},
	{ 0x05B3, 3, 0x11, 0x11, "SERDOUT1 lane assignment"},
	{ 0x05B5, 3, 0x22, 0x22, "SERDOUT2 lane assignment"},
	{ 0x05B6, 3, 0x33, 0x33, "SERDOUT3 lane assignment"},
	{ 0x05BF, 3, 0x05, 0x05, "JESD serializer drive"},
	{ 0x05C1, 3, 0x00, 0x00, "De-emphasis en [6] SERDOUT3 [4] 2 [2] 1 [0] 0"},
	{ 0x05C2, 3, 0x05, 0x00, "[3:0] SERDOUT0 de-emphaisi settings"},
	{ 0x05C3, 3, 0x05, 0x00, "[3:0] SERDOUT1 de-emphaisi settings"},
	{ 0x05C4, 3, 0x05, 0x00, "[3:0] SERDOUT2 de-emphaisi settings"},
	{ 0x05C5, 3, 0x05, 0x00, "[3:0] SERDOUT3 de-emphaisi settings"},
	                          
	{ 0, 0, 0, 0, NULL}
};

#endif /* __AD9234_H_ */