#ifndef __ADC12J4000_H_
#define __ADC12J4000_H_

#include "devices.h"


const reg_with_name_t adc12j4000_regs[] =
{
	{ 0x0000, 3, 0x3c, 0x3c, "Cfg_A"},
	{ 0x0001, 1, 0x00, 0x00, "Cfg_B"},
	{ 0x0002, 3, 0x00, 0x00, "Device configuration"},
	{ 0x0003, 1, 0x03, 0x03, "Chip type = 0x03"},
	{ 0x0006, 1, 0x03, 0x03, "Chip version = 0x03"},
	{ 0x000C, 1, 0x51, 0x51, "Vender ID = 0x51"},
	{ 0x000D, 1, 0x04, 0x04, "Vender ID = 0x04"},
	                          
	{ 0x0010, 3, 0x00, 0x00, "SPI configuration"},
	                          
	{ 0x0021, 3, 0x00, 0x00, "Power on reset"},
	{ 0x0022, 3, 0x40, 0x40, "I/O gain 0"},
	{ 0x0023, 3, 0x00, 0x00, "I/O gain 1"},
	{ 0x0025, 3, 0x40, 0x40, "I/O offset 0"},
	{ 0x0026, 3, 0x00, 0x00, "I/O offset 1"},
	                          
	{ 0x0030, 3, 0xC0, 0xC0, "Clock generator control 0"},
	{ 0x0031, 1, 0x07, 0x07, "Clock generator status"},
	{ 0x0032, 3, 0x80, 0x80, "Clock generator control 2"},
	{ 0x0033, 3, 0xC3, 0xC3, "Analog miscellaneous"},
	{ 0x0034, 3, 0x2F, 0x2F, "Input clamp enable"},
	                          
	{ 0x0040, 3, 0x04, 0x04, "Serializer configuration"},
	                          
	{ 0x0050, 3, 0x06, 0x06, "Calibration configuration 0"},
	{ 0x0051, 3, 0xF4, 0xF4, "Calibration configuration 1"},
	{ 0x0057, 3, 0x10, 0x10, "Calibration background control"},
	{ 0x0058, 3, 0x00, 0x00, "ADC pattern and over-range enable"},
	{ 0x005A, 3, 0x00, 0x00, "Calibration vector"},
	{ 0x005B, 1, 0x00, 0x00, "Calibration status"},
	{ 0x0066, 3, 0x03, 0x02, "Timing calibration"},
	                          
	{ 0x0200, 3, 0x30, 0x10, "Digital down-converter (DDC) control"}, // change: output sample format = 2's complement for bypass mode
	{ 0x0201, 3, 0x17, 0x0F, "JESD204B control 1"},	// change k=6
	{ 0x0202, 3, 0x00, 0x00, "JESD204B control 2"},
	{ 0x0203, 3, 0x00, 0x00, "JESD204B Device ID"},
	{ 0x0204, 3, 0x00, 0x00, "JESD204B control 3"},
	{ 0x0205, 1, 0x00, 0x00, "JESD204B status [6] link up; [5]: sync~ deasserted; [4] realigned; [3] aligned; [2] pll_locked"},
	{ 0x0206, 3, 0xF2, 0xF2, "Over-range control 0"},
	{ 0x0207, 3, 0xAB, 0xAB, "Over-range control 1"},
	{ 0x0208, 3, 0x00, 0x00, "Over-range period"},
	{ 0x020C, 3, 0x00, 0x00, "DDC configuration preset mode"},
	{ 0x020D, 3, 0x00, 0x00, "DDC configuration preset select"},
	{ 0x0050, 2, 0x0e, 0x06, "Calibration configuration 0"},
	
	{ 0, 0, 0, 0, NULL}
};

#endif /* __ADC12J4000_H_ */